
package de.ivu.elect.presentation.email;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.email.boundary.EmailVorlageConversationStore;
import de.ivu.elect.business.email.boundary.EmailVorlageExtendedDAO;
import de.ivu.elect.business.email.boundary.EmailVorlageEdit;
import de.ivu.elect.business.email.entity.EmailVorlage;
import de.ivu.elect.business.email.entity.EmailVorlageMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractEmailVorlageEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractEmailVorlageEditNoScopeView.VIEW_ID, useCase = UseCasePermission.EMAIL_VORLAGE_EDIT)
public abstract class AbstractEmailVorlageEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<EmailVorlage>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "emailVorlageEditView";

  public static final String VIEW_ID = "/email/email-vorlage-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/email/email-vorlage-search.xhtml";

  @Inject
  protected transient EmailVorlageExtendedDAO extendedDAO;

  @Inject
  protected transient EmailVorlageEdit edit;

  @Inject
  @ConversationGroup(EmailVorlageConversationStore.class)
  protected transient EmailVorlageConversationStore conversationStore;

  @Inject
  protected transient EmailVorlageMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient EmailVorlageEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public EmailVorlage getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(EmailVorlage entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_VORLAGE_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(EmailVorlage entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_VORLAGE_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.EMAIL_VORLAGE_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_VORLAGE_EDIT)
  @Override
  public String save() {
    EmailVorlage entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(EmailVorlage entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    EmailVorlage entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(EmailVorlage entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.EMAIL_VORLAGE_EDIT);
  }
  
  @Redirect
  public String edit(EmailVorlage entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class EmailVorlageEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<EmailVorlage,   de.ivu.elect.business.email.entity.EmailVorlagePK  > {

    private static final long serialVersionUID = 1L;
  }
}
